import { defineComponent as E, ref as m, reactive as K, onMounted as p, onUnmounted as I, provide as V, readonly as P, renderSlot as A } from "vue";
import { checkGoogleReCaptchaInjected as C, injectGoogleReCaptchaScript as j, removeGoogleReCaptchaScript as B, removeGoogleReCaptchaContainer as H, removeGoogleReCaptchaBadge as L, hideGoogleReCaptchaBadge as S } from "@google-recaptcha/core";
import { RECAPTCHA_KEY as O } from "../plugins/google-recaptcha-plugin.js";
const W = "onGoogleReCaptchaLoad", $ = "google-recaptcha-container", U = /* @__PURE__ */ E({
  __name: "GoogleReCaptchaProvider",
  props: {
    type: {},
    explicit: {},
    host: {},
    isEnterprise: { type: Boolean },
    language: {},
    scriptProps: {},
    siteKey: {}
  },
  emits: ["load", "error"],
  setup(e, { emit: R }) {
    var d, g, s;
    const l = R, o = m(!0), a = m(), G = (n) => {
      var i;
      if (!((i = a.value) != null && i.execute))
        throw new Error("Google ReCaptcha has not been loaded");
      return a.value.execute(e.siteKey, { action: n });
    }, w = (n) => {
      var i;
      if (!((i = a.value) != null && i.execute))
        throw new Error("Google ReCaptcha has not been loaded");
      return a.value.execute(n);
    }, c = K({
      googleReCaptcha: a,
      siteKey: e.siteKey,
      isLoading: o,
      language: e.language,
      executeV3: G,
      executeV2Invisible: w,
      reset: (d = a.value) == null ? void 0 : d.reset,
      getResponse: (g = a.value) == null ? void 0 : g.getResponse,
      render: (s = a.value) == null ? void 0 : s.render
    });
    return p(() => {
      var v, h, u, y, x;
      const n = ((v = e.scriptProps) == null ? void 0 : v.id) ?? `google-recaptcha-${e.type}-script`, i = C(), r = () => {
        var b, f;
        const t = e.isEnterprise ? (b = window.grecaptcha) == null ? void 0 : b.enterprise : window.grecaptcha;
        if (!t) {
          l("error");
          return;
        }
        if (e.explicit || t.ready(async () => {
          a.value = t, c.reset = t.reset, c.getResponse = t.getResponse, c.render = t.render, l("load", t), o.value = !1;
        }), e.explicit) {
          const k = {
            size: e.type === "v3" || e.type === "v2-invisible" ? "invisible" : "normal",
            ...(e.type === "v3" || e.type === "v2-invisible") && { badge: "bottomright" },
            sitekey: e.siteKey,
            ...e.explicit,
            "expired-callback": e.explicit.expiredCallback,
            "error-callback": e.explicit.errorCallback
          };
          i || (e.type === "v3" || e.type === "v2-invisible") && ((f = e.explicit) == null ? void 0 : f.badge) === "hidden" && S(), t.ready(async () => {
            e.explicit.container && t.render(e.explicit.container, k, !!e.explicit.inherit), a.value = t, c.reset = t.reset, c.getResponse = t.getResponse, c.render = t.render, l("load", t), o.value = !1;
          });
        }
      };
      window[W] = r, i ? r() : j({
        isEnterprise: e.isEnterprise,
        host: e.host,
        ...(e.type === "v3" || e.type === "v2-invisible") && ((h = e.explicit) == null ? void 0 : h.badge) && {
          badge: ((u = e.explicit) == null ? void 0 : u.badge) === "hidden" ? "bottomright" : (y = e.explicit) == null ? void 0 : y.badge
        },
        ...e.language && { hl: e.language },
        render: (e.type === "v3" || e.type === "v2-invisible") && ((x = e.explicit) != null && x.container) || e.type === "v2-checkbox" ? "explicit" : e.siteKey,
        ...e.scriptProps,
        onload: r,
        id: n
      });
    }), I(() => {
      var n, i;
      C() && B(), (e.type === "v3" || e.type === "v2-invisible") && !((n = e.explicit) != null && n.container) && ((i = e.explicit) != null && i.badge) ? H($) : L();
    }), V(O, P(c)), (n, i) => A(n.$slots, "default");
  }
});
export {
  U as default
};
//# sourceMappingURL=GoogleReCaptchaProvider.vue.js.map
